Description

Description of problem:

After Overriding the value of Smart class Parameter and validating the new default value with validator type 'list' fails.

Version-Release number of selected component (if applicable):

foreman-1.10.0-0.develop.201510011619git0033595.el7.noarch

foreman-release-scl-1-1.el7.x86_64

How reproducible:

Always

Steps to Reproduce:

1. Override the default value of a smart class parameter.

2. Select the key type as array/string.

3. Give new default value as [1]/1. (Just an example, anything can be provided)

4. In Optional Input Validator, Select validator type as list.

5. In Validator Rule, give some list of values in which the new default value should be present. In my case its [1,2].

6. Try to submit this change.

Actual results:

1. Validation Failed.

2. Not allowing to submit the change and labelling '[1] is not one of [1,2]' or '1 is not one of [1,2]' for Default Value field.

Expected results:

Should be allowed to submit the change and validation should pass as obvious in above case.

Associated revisions

Revision baaf6b49 - 10/08/2015 02:38 AM - Ori Rabin

Fixes #12078 - list validator in smart class parameters validates any string coercible value

Revision 9174d8a3 - 10/14/2015 07:49 AM - Ori Rabin

Fixes #12078 - list validator in smart class parameters validates any string coercible value

(cherry picked from commit baaf6b49271f7f5035cb01773723135d12afc5e1)

History

#1 - 10/07/2015 03:23 AM - Dominic Cleal

- Priority changed from High to Normal

The list validator shouldn't contain brackets, unless you're trying to validate their presence, i.e. [1

Using a basic validator against an array wouldn't work.  Do you expect it to validate every element?  Recursively?  This is a feature request, not a

bug.
#2 - 10/07/2015 03:23 AM - Dominic Cleal

- Status changed from New to Need more information

#3 - 10/07/2015 04:03 AM - Jitendra Yejare

Ok. Got it.

I tried one more scenario here:

Key type as 'Integer' & default value 1 with Validator Type as 'list' & Validator rule as 1,2 (without brackets). This fails saying '1 is not one of 1,2'.

But It works if Key Type set to 'String with Validator type 'list' and rule 1,2 (without brackets).

#4 - 10/07/2015 04:15 AM - The Foreman Bot

- Status changed from Need more information to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2788 added

- Pull request deleted ()

#5 - 10/08/2015 02:38 AM - Daniel Lobato Garcia

- Subject changed from In Smart Class Parameter, the validation for validator type 'list' is not working as expected. to 'List' validation for Smart Class

params should work for any string coercible value

I'll rephrase the title so that it matches what the pull request fixes.

#6 - 10/08/2015 02:59 AM - Dominic Cleal

- translation missing: en.field_release set to 63

#7 - 10/08/2015 03:01 AM - Ori Rabin

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset baaf6b49271f7f5035cb01773723135d12afc5e1.
